package net.wanji.opt.service;

import com.fasterxml.jackson.core.JsonProcessingException;
import net.wanji.databus.bo.CrossIdBO;
import net.wanji.databus.vo.GreenwaveListVO;
import net.wanji.opt.bo.*;
import net.wanji.opt.dto.trend.AbnormalCrossListDTO;
import net.wanji.opt.dto.trend.GreenwaveListDTO;
import net.wanji.opt.po.trend.AnalysisRidTurnIndicators;
import net.wanji.opt.po.trend.HoloEventInfoPO;
import net.wanji.opt.vo.*;

import javax.servlet.http.HttpServletResponse;
import java.text.ParseException;
import java.util.Date;
import java.util.List;

/**
 * @date 2023/1/12 15:12
 * @desc 态势监测接口服务
 */
public interface TrendService {

    List<GreenwaveListVO> greenwaveList(GreenwaveListDTO greenwaveListDTO);

    GreenwaveStats buildGreenwaveStats(List<GreenwaveListVO> greenwaveListVOList);

    AbnormalCrossVO abnormalCrossList(AbnormalCrossListDTO abnormalCrossListDTO);

    AbnormalCrossDetailVO abnormalCrossDetail(CrossIdBO crossIdBO);

    List<EventAlarmVO> eventAlarm(Date todayTime) throws ParseException;

    List<GreenWaveCrossMonitorVO> greenwaveCrossMonitor(GreenwaveIdBO greenwaveIdBO);

    List<GreenwaveRunMonitorVO> greenwaveRunMonitor(GreenwaveIdBO greenwaveIdBO);

    GreenwaveDetailVO greenwaveDetail(GreenwaveDetailBO greenwaveDetailBO);

    List<GreenwaveCrossMetricsVO> greenwaveCrossMetrics(GreenwaveIdAndTimeStampBO greenwaveIdAndTimeStampBO) throws JsonProcessingException;

    void saveGreenwaveStrategy(SaveGreenwaveStrategyBO saveGreenwaveStrategyBO);

    GreenwaveDetailVO currentGreenwaveDetail(GreenwaveIdBO bo) throws Exception;

    CountRealTimeVO countRealTime(String crossId) throws Exception;

    TableQueryVO tableQuery(CrossIdAndTimeSpanBO crossIdAndTimeSpanBO) throws Exception;

    TableQueryVO tableRealTime(CrossIdAndIsFirstBO crossIdAndIsFirstBO) throws Exception;

    OptTypeVO optType(CrossIdBO crossIdBO);

    List<HotspotCrossVO> hotspotCross(CommonCrossIdVO commonCrossIdVO) throws Exception;

    List<HotspotCrossTurnVO> crossTurnData(CommonCrossIdVO commonCrossIdVO) throws Exception;

    List<HotspotCrossLaneVO> crossLaneData(CommonCrossIdVO commonCrossIdVO) throws Exception;

    List<Top5IndexVO>  top5Flow() throws Exception;

    CrossStatusTimeRateVO crossStatusTimeRate(CommonCrossIdVO commonCrossIdVO) throws Exception;

    List<TableQueryVO.CycleDataElement> laneTrafficIndex(CommonCrossIdDateTimeVO crossIdDateTimeVO) throws Exception;

    List<TableQueryVO.RealTimeDataElement> laneSnapshotIndex(LaneSnapshotIndexVO laneSnapshotIndexVO) throws Exception;

    List<AnalysisRidTurnIndicators> lanePeriodTurnData(LanePeriodTurnVO lanePeriodTurnVO) throws Exception;

    List<HoloEventInfoPO> holoEvenList(HoloEventVO holoEventVO) throws Exception;

    List<LaneIdAliasNameVO> laneIdList(CommonCrossIdVO commonCrossIdVO) throws Exception;

    void periodExcel(CommonCrossIdDateTimeVO crossIdDateTimeVO, HttpServletResponse response) throws Exception;
}
